<?php
// 应用公共文件

use think\facade\Config;
use think\facade\Db;
use think\facade\Filesystem;
// 应用公共文件
function app_show($code=0,$message="",$data=[]){
    $result = ['code'=>$code,"message"=>$message,"data"=>$data];
    echo json_encode($result,JSON_UNESCAPED_UNICODE);
    die();
}

// 应用公共文件
function error_show($code=0,$message=""){
    $result = ['code'=>$code,"message"=>$message];
    echo json_encode($result,JSON_UNESCAPED_UNICODE);
    die();
}

function GetUserInfo($token){
    $host = Config::get("app");
    $url = $host["api_host"]."/Api/userinfo";
    $data=[
        "token"=>$token
    ];
    $response=curl_request($url,$data);

    return json_decode($response,true);
}
//参数1：访问的URL，参数2：post数据(不填则为GET)，参数3：提交的$cookies,参数4：是否返回$cookies
function curl_request($url,$post=''){
    $curl = curl_init();
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_USERAGENT, 'Mozilla/5.0 (compatible; MSIE 10.0; Windows NT 6.1; Trident/6.0)');
    curl_setopt($curl, CURLOPT_FOLLOWLOCATION, 1);
    curl_setopt($curl, CURLOPT_AUTOREFERER, 1);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
    if($post) {
        curl_setopt($curl, CURLOPT_POST, 1);
        curl_setopt($curl, CURLOPT_POSTFIELDS, http_build_query($post));
    }
    curl_setopt($curl, CURLOPT_TIMEOUT, 10);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
    $data = curl_exec($curl);
    if (curl_errno($curl)) {
        return curl_error($curl);
    }
    curl_close($curl);
    return $data;

}

/**手机号验证
 * @param $mobile
 * @return bool
 */
function checkMobile($mobile){
    if (!is_numeric($mobile)) {
        return false;
    }
    return preg_match('#^1[3,4,5,6,7,8,9]{1}[\d]{9}$#', $mobile) ? true : false;
}

function checkTel($tel){
    if (!$tel) {
        return false;
    }
    return preg_match('/^(0[0-9]{2,3}\-)([0-9]{7,8})+(\-[0-9]{1,4})?$/', $tel) ? true : false;
}
/**邮箱验证
 * @param $email
 * @return bool
 */
function checkEmail($email){
    if (!$email) {
        return false;
    }
    return preg_match('#[a-z0-9&\-_.]+@[\w\-_]+([\w\-.]+)?\.[\w\-]+#is', $email) ? true : false;

}

/**
 * @param
 * @return int
 */
function makeSalt(){
    $salt = rand(10000000,99999999);
    return $salt;
}



/**
 * @param $token
 * @return array
 * @throws \think\db\exception\DataNotFoundException
 * @throws \think\db\exception\DbException
 * @throws \think\db\exception\ModelNotFoundException
 * @throws \think\exception\DbException
 */
function VerifyTokens($token){
    $host = Config::get("app");
    $url = $host["api_host"]."/Api/verify_token";
    $data=[
        "token"=>$token
    ];
    $response=curl_request($url,$data);

    return json_decode($response,true);
}


/**
 * @param $token
 * @param $condition
 * @return mixed
 */
function GetUserlist($token,$condition){
    $host = Config::get("app");

    $url = $host["api_host"]."/Api/getuserlist";
    $condition['token']=$token;
    $response=curl_request($url,$condition);

    return json_decode($response,true);
}

/**
 * @param $token
 * @param $condition
 * @return mixed
 */
function GetAccountall($token, $condition){
    $host = Config::get("app");

    $url = $host["api_host"]."/Api/userall";
    $condition['token']=$token;
    $response=curl_request($url,$condition);

    return json_decode($response,true);
}

function GetList($token,$condition){
    $host = Config::get("app");

    $url = $host["api_host"]."/Api/userlist";
    $condition['token']=$token;
    $response=curl_request($url,$condition);

    return json_decode($response,true);
}

/**
 * @param $token
 * @param $condition ['id'=>1]
 * @return mixed
 */
function GetInfoById($token,$condition){
    $host = Config::get("app");
    $url = $host["api_host"]."/Api/userinfobyid";
    $condition['token']=$token;
    $response=curl_request($url,$condition);
    return json_decode($response,true);
}

function makeNo($str){

    $date=date("mdHis");
    $year = date("Y")-2000;
    $msec=rand(1000,9999);
    return $str.$year.$date.$msec;
}
function randomkeys($length) {
    $returnStr='';
    $pattern = '1234567890abcdefghijklmnopqrstuvwxyz';//ABCDEFGHIJKLOMNOPQRSTUVWXYZ

    for($i = 0; $i < $length; $i ++) {
        $returnStr .= $pattern[mt_rand ( 0, strlen($pattern)-1 )]; //生成php随机数
    }
    return $returnStr;
}
function tree(){

}
/**
 * @param $files
 * @return array
 */
function UploadImg($files)
{
    $savename = [];
    $files = !is_array($files) ? [$files] : $files;
    try {
        //验证
        validate(['imgFile' => ['fileSize' => 10240000, 'fileExt' => 'jpg,jpeg,png,bmp,gif', 'fileMime' => 'image/jpeg,image/png,image/gif']])->check(['imgFile' => $files]);

        foreach ($files as $file) {
            $url = Filesystem::disk('public')->putFile('topic/' . date("Ymd"), $file, function () use ($file) {
                return str_replace('.' . $file->getOriginalExtension(), '', $file->getOriginalName() . "_" . date('YmdHis'));
            });
            $name = str_replace('.' . $file->getOriginalExtension(), '', $file->getOriginalName());
            $temp = ["url" => $url, "name" => $name];
            $savename[] = $temp;
        }

        return $savename;
    } catch (\think\exception\ValidateException $e) {

        return $e->getMessage();
    }
}
/**
 * @param $files
 * @return array
 */
function UploadFile($files)
{
    $savename = [];
    $files = !is_array($files) ? [$files] : $files;
    try {
        //验证
        validate(['imgFile' => ['fileSize' => 10240000,'fileExt' => 'xlsx,xls,pdf,zip,rar,7z,doc,docx']])->check(['imgFile' =>
            $files]);

        foreach ($files as $file) {
            $url = Filesystem::disk('public')->putFile('files/' . date("Ymd"), $file, function () use ($file) {
                return str_replace('.' . $file->getOriginalExtension(), '', $file->getOriginalName() . "_" . date('YmdHis'));
            });
            $name = str_replace('.' . $file->getOriginalExtension(), '', $file->getOriginalName());
            $temp = ["url" => $url, "name" => $name];
            $savename[] = $temp;
        }

        return $savename;
    } catch (\think\exception\ValidateException $e) {

        return $e->getMessage();
    }
}

/**
 * @param $files
 * @return array
 */
function UploadVideo($files)
{
    $savename = [];
    $files = !is_array($files) ? [$files] : $files;
    try {
        //验证
        validate(['videoFile' => ['fileSize' => 10240000,'fileExt' => 'mp4,mp3,avi']])->check(['videoFile' => $files]);

        foreach ($files as $file) {
            $url = Filesystem::disk('public')->putFile('video/' . date("Ymd"), $file, function () use ($file) {
                return str_replace('.' . $file->getOriginalExtension(), '', $file->getOriginalName() . "_" . date('YmdHis'));
            });
            $name = str_replace('.' . $file->getOriginalExtension(), '', $file->getOriginalName());
            $temp = ["url" => $url, "name" => $name];
            $savename[] = $temp;
        }

        return $savename;
    } catch (\think\exception\ValidateException $e) {

        return $e->getMessage();
    }
}
/**
 * @param $token
 * @param $condition
 * @return mixed
 */
 function resetpwd($token,$condition){
     $host = Config::get("app");

     $url = $host["api_host"]."/Api/passset";
     $condition['token']=$token;
     $response=curl_request($url,$condition);

     return json_decode($response,true);
 }

function resetpasswd($token,$condition){
    $host = Config::get("app");

    $url = $host["api_host"]."/Api/passsave";
    $condition['token']=$token;
    $response=curl_request($url,$condition);

    return json_decode($response,true);
}

/**
 * @param $token
 * @param $condition
 * @return mixed
 */
function resetinfo($token,$condition){
    $host = Config::get("app");

    $url = $host["api_host"]."/Api/usersave";
    $condition['token']=$token;
    $response=curl_request($url,$condition);

    return json_decode($response,true);
}

/**
 * @param $token
 * @param $condition
 * @return mixed
 */
function resetstatus($token,$condition){
    $host = Config::get("app");

    $url = $host["api_host"]."/Api/userstatus";
    $condition['token']=$token;
    $response=curl_request($url,$condition);

    return json_decode($response,true);
}

/**
 * @param $data
 * @throws \think\db\exception\DataNotFoundException
 * @throws \think\db\exception\DbException
 * @throws \think\db\exception\ModelNotFoundException
 */
function crea($data,$vio=0)
{
    $db = Db::name("company_item")->where(['pid'=>$data['id'],'is_del'=>0])->select()->toArray();
    if($vio==1){
        $d = Db::name("depart_user")->where(['itemid'=>$data['id'],'is_del'=>0])->select()->toArray();
        if(empty($d)){
            $data['item']=[];
        }else{
            $data['item']=$d;
        }
    }

   if(empty($db)){
       $data['child']=[];
      return $data;
   }
   //var_dump($db);
    foreach ($db as $p){
        $data['child'][]=crea($p,$vio);
    }
    return $data;
}

function GetPart($id,$data=[]){
    $db = Db::name("company_item")->where(['id'=>$id,'is_del'=>0])->find();
    if($db==false){
        return [];
    }
    $tem=[];
    $tem['id']=$db['id'];
    $tem['name']=$db['name'];
    array_unshift($data,$tem);
    if($db['pid']==0){
        // krsort($data);
        return $data;
    }else{
        return GetPart($db['pid'],$data);
    }
}

function stro($data){
    $db=Db::name('cat')->where(['pid'=>$data['id']])->select()->toArray();
    if(empty($db)){
        $data['child']=[];
        return $data;
    }
    foreach ($db as $item) {
        $data['child'][]=stro($item);
    }
    return $data;
}

function coco($data){
    $db=Db::name('exclusive')->where(['pid'=>$data['id']])->select()->toArray();
    if(empty($db)){
        $data['child']=[];
        return $data;
    }
    foreach ($db as $item) {
        $data['child'][]=coco($item);
    }
    return $data;
}

function mai($var,$data=[]){
    $str = Db::name('exclusive')->where(['id'=>$var])->find();
    if($str==false){
        return [];
    }
    $vmn =[];
    $vmn['id'] =$str['id'];
    $vmn['rname'] =$str['name'];
    array_unshift($data,$vmn);
    // $var['id']=made();
    if($str['pid']==0){
        // krsort($data);
        return $data;
    }else{
        return mai($str['pid'],$data);
    }
}

function made($var,$data=[]){
    $str = Db::name('cat')->where(['id'=>$var])->find();
    if($str==false){
        return [];
    }
    $vmn =[];
    $vmn['id'] =$str['id'];
    $vmn['name'] =$str['cat_name'];
    array_unshift($data,$vmn);
   // $var['id']=made();
    if($str['pid']==0){
       // krsort($data);
        return $data;
    }else{
        return made($str['pid'],$data);
    }
}
function catChild($var,&$data=[]){
    $str = Db::name('cat')->where(['id'=>$var])->find();
    if($str==false){
        return;
    }
    $data[]=$var;
   $lsit = Db::name("cat")->where(["pid"=>$var,"status"=>1,"is_del"=>0])->column("id");
   if(!empty($lsit)){
       foreach ($lsit as $value){
           catChild($value,$data);
       }
   }
   return $data;
}


function makeExcluse($var,$data=[]){
    $str = Db::name('exclusive')->where(['id'=>$var])->find();
    if($str==false){
        return [];
    }
    $vmn =[];
    $vmn['id'] =$str['id'];
    $vmn['name'] =$str['name'];
    array_unshift($data,$vmn);
    // $var['id']=made();
    if($str['pid']==0){
        // krsort($data);
        return $data;
    }else{
        return makeExcluse($str['pid'],$data);
    }
}

function sear($id){
    $item = Db::name('cat')->where(['id'=>$id])->field("search")->find();
    if($item==false){
       return false;
    }else{
        $temp = Db::name('cat')->where(['pid'=>$id,'is_del'=>0])->select();
        if ($temp==false){
            return false;
        }
    }
    foreach ($temp as $value){
        $value['search']=$item['search']."_".$value['cat_name'];

        $list = Db::name('cat')->save($value);
         sear($id);
    }
}

function manger($list=[],$level=1){
    $var = Db::name('cat')->where(['pid'=>$list,'level'=>$level+1])->column("id");
    if(empty($var)){
        return $list;
    }
    $a=array_merge($list,$var);
    return manger($a,$level+1);
}
/**
 * @param $files
 * @param string $extend
 * @return array
 * @throws PHPExcel_Exception
 * @throws PHPExcel_Reader_Exception
 */
function upload_excel($files,$extend="xls")
{
    // 获取表单上传文件
    try {
        validate([
            'file' => [
                // 限制文件大小(单位b)，这里限制为4M
                //fileSize' => 4 * 1024 * 1024,
                'fileExt' => 'xlsx,xls'
            ]
        ],
            [
                //'file.fileSize' => '文件太大',
                'file.fileExt' => '不支持的文件',
            ]
        )->check(['file' => $files]);

        // $name = $files->getOriginalExtension();
        if ($extend == 'xlsx') {
            $objReader = PHPExcel_IOFactory::createReader('Excel2007');
        } else {
            $objReader = PHPExcel_IOFactory::createReader('Excel5');
        }

        $savename = Filesystem::disk('public')->putFile('topic/excel', $files);
        $import_path = root_path() . 'public/storage/' . $savename;

        $spreadsheet = $objReader->load($import_path);
        $sheet = $spreadsheet->getActiveSheet();
        $sheetData = $sheet->toArray();
        if (empty($sheetData) || !is_array($sheetData)) {
            return ['code' => 1003, "msg" => '数据不能为空'];
        }
        $list = [];

        foreach ($sheetData as $key => $value) {
            $list[] = $value;
        }
        return ['code' => 0, "msg" => '数据解析成功', 'data' => $list];
    } catch (think\exception\ValidateException $e) {
        // echo $e->getMessage();
        return ['code' => 1003, "msg" => $e->getMessage()];
    }
}
/**
 * @param string $fileName
 * @param array $headArr
 * @param array $data
 */
function excelSave($fileName = '', $headArr = [], $data = [])
{
    $objPHPExcel = new PHPExcel();
    $objPHPExcel->getProperties();
    $keyA = 0; // 设置表头
    foreach ($headArr as $v) {
        $colum = PHPExcel_Cell::stringFromColumnIndex($keyA);
        $objPHPExcel->setActiveSheetIndex(0)->setCellValue($colum . '1', $v);
        $keyA += 1;
    }

    $column = 2;
    $objActSheet = $objPHPExcel->getActiveSheet();

    foreach ($data as $key => $rows) { // 行写入
        $span = 0;
        foreach ($rows as $keyName => $value) { // 列写入
            //判断数据是否有数组，如果有数组，转换成字符串

            if(is_array($value)){
                $value = implode("、", $value);
            }
            $objActSheet->setCellValue(PHPExcel_Cell::stringFromColumnIndex($span) . $column, $value);
            $span++;
        }
        $column++;
    }
    //  var_dump($objActSheet->getActiveCell());
    $file = $fileName. ".xls";
    //$fileName .= "_" . date("Y_m_d", Request()->instance()->time()) . ".xls";
    //$fileName = iconv("utf-8", "gb2312", $fileName); // 重命名表
    $dir =root_path() . 'public/storage/report/'.date("YmdHis")."/";
    if(!is_dir($dir)){
        mkdir($dir,0777,true);
    }
    $objPHPExcel->setActiveSheetIndex(0); // 设置活动单指数到第一个表,所以Excel打开这是第一个表
    $objWriter = \PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');
    $objWriter->save($dir . $file); // 文件通过浏览器下载
    $url = $dir . $file;
    if(!file_exists($url)){
        echo "文件生成失败";
    }
    $saveDir = root_path()."public/storage/zip/";
    if(!is_dir( $saveDir)){
        mkdir($saveDir,0777,true);
    }
    $datetime = date("Y-m-d H:i:s");
    $file_dir = $saveDir.$datetime.".zip";
    # 5.1 文件打包，提示：使用本类，linux需开启zlib，windows需取消php_zip.dll前的注释
    $zip = new \ZipArchive ();
    # 5.2 文件不存在则生成一个新的文件 用CREATE打开文件会追加内容至zip
    if ($zip->open($file_dir, \ZipArchive::OVERWRITE) !== true && $zip->open($file_dir, \ZipArchive::CREATE) !==
        true) echo '无法打开文件或者文件创建失败';

    # 5.3 批量写入压缩包
    $zip->addEmptyDir($fileName);
    // @$zip->addFile($v['file_path'], 'resume'.DIRECTORY_SEPARATOR.basename($headername));
    @$zip->addFile($url,$fileName.DIRECTORY_SEPARATOR.basename($url));
    # 5.4 关闭压缩包写入
    $zip->close();
    @deldir($dir);
    # 6. 检查文件是否存在，并输出文件
    if (! file_exists ( $file_dir ))  echo '简历文件不存在';

    ob_clean();
    flush();
    header("Cache-Control: max-age=0");
    header("Content-Description: File Transfer");
    header('Content-disposition: attachment; filename=' . basename($file_dir)); # 处理文件名
    header("Content-Type: application/octet-stream");                           # 流文件输出
    header("Content-Transfer-Encoding: binary");                                # 告诉浏览器，这是二进制文件
    header('Content-Length: ' . filesize($file_dir));                           # 告诉浏览器，文件大小
    readfile($file_dir);                                                        # 输出文件
    @ unlink($file_dir);
    exit();
}

function deldir($path){
    //如果是目录则继续
    if(is_dir($path)){
        //扫描一个文件夹内的所有文件夹和文件并返回数组
        $p = scandir($path);
        //如果 $p 中有两个以上的元素则说明当前 $path 不为空
        if(count($p)>2){
            foreach($p as $val){
                //排除目录中的.和..
                if($val !="." && $val !=".."){
                    //如果是目录则递归子目录，继续操作
                    if(is_dir($path.$val)){
                        //子目录中操作删除文件夹和文件
                        deldir($path.$val.'/');
                    }else{
                        //如果是文件直接删除
                        unlink($path.$val);
                    }
                }
            }
        }
    }
    //删除目录
    return rmdir($path);
}

/**
 * @param string $AddrJson
 */
function GetAddr($AddrJson=""){
    if($AddrJson==""){
        return '';
    }
    $adr = json_decode($AddrJson,true);
    if(!is_array($adr)){
        return '';
    }
    $addr='';
    if(isset($adr['provice_code'])&&$adr['provice_code']!=''){
        $provice = Db::name("province")->where(["province_code"=>$adr['provice_code']])->find();
        $addr.=isset($provice['name']) ? $provice['name']:"";
    }
    if(isset($adr['city_code'])&&$adr['city_code']!=''){
        $city = Db::name("city")->where(["city_code"=>$adr['city_code']])->find();
        $addr.=isset($city['name']) ? $city['name']:"";
    }
    if(isset($adr['area_code'])&&$adr['area_code']!=''){
        $area = Db::name("area")->where(["area_code"=>$adr['area_code']])->find();
        $addr.=isset($area['name']) ? $area['name']:"";
    }
    return $addr;
}
/**
 * POST 请求
 * @param string $url
 * @param array $param
 * @param boolean $post_file 是否文件上传
 * @return string content
 */
function post($url,$data,$header=[])
{
    //对空格进行转义
    $url = str_replace(' ','+',$url);
    $ch = curl_init();

    //设置选项，包括URL
    curl_setopt($ch, CURLOPT_URL, "$url");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch,CURLOPT_TIMEOUT,3);  //定义超时3秒钟
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    // POST数据
    //  curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
    curl_setopt($ch, CURLOPT_POST, 1);
    // 把post的变量加上
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data);    //所需传的数组用http_bulid_query()函数处理一下，就ok了
    curl_setopt($ch, CURLOPT_HEADER, true);
    //执行并获取url地址的内容
    $output = curl_exec($ch);
    $errorCode = curl_errno($ch);
    //释放curl句柄
    $headerSize = curl_getinfo($ch, CURLINFO_HEADER_SIZE);

// 根据头大小去获取头信息内容

    $header = substr($output, 0, $headerSize);


    curl_close($ch);
    if(0 !== $errorCode) {
        return false;
    }
    return $header;
}

function post2($url,$data,$header=[])
{
    //对空格进行转义
    $url = str_replace(' ','+',$url);
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);

    //设置选项，包括URL
    curl_setopt($ch, CURLOPT_URL, "$url");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    // POST数据
    curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
    curl_setopt($ch, CURLOPT_POST, 1);
    // 把post的变量加上
    curl_setopt($ch, CURLOPT_POSTFIELDS, $data);    //所需传的数组用http_bulid_query()函数处理一下，就ok了
    $output = curl_exec($ch);
    $errorCode = curl_errno($ch);
    curl_close($ch);
    if(0 !== $errorCode) {
        return false;
    }
    return $output;
}

function GoldPrice($data,$cost_rate=0){
    $gold = Db::name("gold_price1")->where(["type"=>$data["metal_id"],"is_del"=>0,"status"=>1])->order("addtime desc")
        ->find();
//    $rate = $data['open_fee']/$data['num'] + $data['weight']* $gold["price"] + $data['cost_fee']/(1-$cost_rate) *
//        $data['weight']+$data['packing_fee']+$data["mark_fee"]+$data["cert_fee"]+$data['nake_fee'];
    $saleprice = ($data['demo_fee']/$data['num']+$data['delivery_fee']+$data['open_fee']/$data['num']+ $data['weight']*
            $gold["price"] + $data['cost_fee'] *$data['weight'] + $data['packing_fee']+ $data["mark_fee"]+ $data["cert_fee"]+$data['nake_fee']) / (1 - $cost_rate);

    return $saleprice;
}

function GoodPrice($data,$cost_rate=0){
    $rate = ($data['open_fee']/$data['num']+ $data['cost_fee']+$data['packing_fee']+$data["mark_fee"]+$data["cert_fee"]+$data['nake_fee'])/(1-$cost_rate
        );
    return $rate;
}

function checkRole($roleid,$menu){
    $roleinfo = Db::name("role_action")->where([['role_id',"=",$roleid],["status","=",1]])->find();
    if($roleinfo['private_data']!=""){

        $private = explode(",",$roleinfo['private_data']);
        if(in_array($menu,$private)){
            return true;
        }
    }
    return false;
}


/**
 * 根据地址解析省市区
 * @param 详细地址，类似于'北京市顺义区xxx路xxx号'
 */
if (!function_exists('get_address')) {

    function get_address(string $address = '')
    {
        preg_match('/(.*?(省|自治区|北京市|天津市|上海市|重庆市|澳门特别行政区|香港特别行政区))/', $address, $matches);
        if (count($matches) > 1) {
            $province = $matches[count($matches) - 2];
            $address = preg_replace('/(.*?(省|自治区|北京市|天津市|上海市|重庆市|澳门特别行政区|香港特别行政区))/', '', $address, 1);
        }
        preg_match('/(.*?(市|自治州|地区|区划|县))/', $address, $matches);
        if (count($matches) > 1) {
            $city = $matches[count($matches) - 2];
            $address = str_replace($city, '', $address);
        }
        preg_match('/(.*?(区|县|镇|乡|街道))/', $address, $matches);
        if (count($matches) > 1) {
            $area = $matches[count($matches) - 2];
            $address = str_replace($area, '', $address);
        }
        return [
            'province' => isset($province) ? $province : '',
            'city' => isset($city) ? $city : '',
            'district' => isset($area) ? $area : '',
            "address" => $address
        ];
    }

}